/*
 * Created on 29.07.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package isac.gui.browser;

import isac.interfaces.IToGUI;
import isac.useractions.IUIAction;
import isac.useractions.IUserAction;
import isac.util.WindowApplicationPaths;

import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.server.UnicastRemoteObject;

/**
 * @author JL
 *
 * @version $Revision$
 */
public class BrowserFrameRMI extends UnicastRemoteObject implements IToGUI{
	
	private BrowserFrame browser_frame_;

	/**
	 * @throws java.rmi.RemoteException
	 */
	public BrowserFrameRMI(BrowserFrame browser_frame) throws RemoteException {
		super();
		rmiBind();
		browser_frame_ = browser_frame;
	}

	private void rmiBind() {
		if (System.getSecurityManager() == null) {
			System.setSecurityManager(new RMISecurityManager());
		}

//		try {
//			LocateRegistry.createRegistry(1066);
//		} catch (java.rmi.RemoteException exc2) {
//			System.err.println("can not create registry: " + exc2.getMessage());
//		}

		String name = WindowApplicationPaths.BROWSER_FRAME_RMI;
		
		try {
			System.out.println("try to bind as " + name);
			Naming.rebind(name, this);
			System.out.println("BrowserFrameRMI bound to " + name);
			//WN040906 was Object Manager ...
		} catch (java.rmi.ConnectException e) {
			System.err.println("failed to contact as " + name
					+ " (creating RMI-Server on localhost: 1099)");
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


	/**
	 * @deprecated
	 * @see isac.interfaces.IToGUI#doUIAction(isac.useractions.IUserAction)
	 */
	public boolean doUIAction(IUserAction action) throws RemoteException {
		browser_frame_.doUIAction(action);		
		return false;
	}

	/**
	 * to do a user interface action
	 * 
	 * @see isac.interfaces.IToGUI#doUIAction(isac.useractions.IUIAction)
	 */
	public void doUIAction(IUIAction action) throws RemoteException {
		browser_frame_.doUIAction(action);
	}

	/**
	 * to add a user interface element
	 * 
	 * @see isac.interfaces.IToGUI#addUIElement(isac.useractions.IUIAction)
	 */
	public void addUIElement(IUIAction action) throws RemoteException {
		browser_frame_.addUIElement(action);
	}

	/**
	 * to remove a user interface element
	 * 
	 * @see isac.interfaces.IToGUI#removeUIElement(isac.useractions.IUIAction)
	 */
	public boolean removeUIElement(IUIAction action) throws RemoteException {
		return browser_frame_.removeUIElement(action);
	}

	public boolean isUIRunning() throws RemoteException {
		return true;
	}
}
