Commands and queries for isac's UserLogger
==========================================
su
/opt/lampp/lampp start
exit
     ### start interactive db-mode
 cd /opt/lampp/bin
 ./mysql -uroot                  
 use userlogger
     ### redirect output to a file (because a record is longer than a line in the default output):
 tee /home/neuper/tmp/output.tex
 
> delete from UserLogger;

example queries
===============
get all:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
> select * from UserLogger;

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[1] who has used isac ?

select UserName, Argument as UserUrl, Time as Begin,
unix_timestamp((select Time from UserLogger where step='UI_STOP_SESSION' and session=ul1.session)) - unix_timestamp(ul1.time) as Duration,
(select count(*) from UserLogger where step='LO_OPEN_WORKSHEET' and session=ul1.session) as Examples
from UserLogger ul1
where step='LO_START_SESSION';

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[2] which examples has a user calculated (over all sessions) ?

select session, Argument as ID, FormulaTo as Example, Time as Begin,
unix_timestamp((select Time from UserLogger where step='LO_STOP_EXAMPLE' and session=ul1.session limit 1)) - unix_timestamp(ul1.time) as Duration,
(select Success from UserLogger where step='LO_STOP_EXAMPLE' and session=ul1.session limit 1) as Success,
(select count(*) from UserLogger where step like 'UI_SOLVE%' and session=ul1.session limit 1) as Calc_Steps,
(select count(*) from UserLogger where step not like 'UI_SOLVE%' and session=ul1.session limit 1) as Other_Steps
from UserLogger ul1
where UserName='x' and Step='LO_OPEN_WORKSHEET';

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[3] what did a user do during a certain session ?

select Dialog, Step, Time, Worksheet, Position, FormulaFrom, FormulaTo, Argument, Substitution, Success
from UserLogger
where Session=2
order by Time;

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[4] what did a user do during a certain example ?

select Dialog, Step, Time, Position, FormulaFrom, FormulaTo, Argument, Substitution, Success
from UserLogger
where Worksheet='1_0'
order by Time;

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[5] how difficult are the examples ?

select Argument as ID, FormulaTo as Example, Success, Success-1 as Failure
from UserLogger
where Step='LO_OPEN_WORKSHEET'
order by Success, Failure;

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[6] who are the most frequent users of isac ?

select UserName, 
(select count(*) from UserLogger where step='LO_OPEN_WORKSHEET' and username=ul1.username limit 1) as Examples,
(select count(*) from UserLogger where step='LO_STOP_EXAMPLE' and username=ul1.username limit 1) as Success,
(select count(*) from UserLogger where step like 'UI_SOLVE%' and username=ul1.username limit 1) as Calc_Steps,
(select count(*) from UserLogger where step not like 'UI_SOLVE%' and username=ul1.username limit 1) as Other_Steps
from UserLogger ul1
where Step='LO_START_SESSION'
group by UserName
order by Examples, UserName;

--old version, NOT CORRECT!!!
select UserName, Argument as UserUrl,
(select count(*) from UserLogger where step='LO_OPEN_WORKSHEET' and session=ul1.session limit 1) as Examples,
(select Success from UserLogger where step='LO_STOP_EXAMPLE' and session=ul1.session limit 1) as Success,
(select count(*) from UserLogger where step like 'UI_SOLVE%' and session=ul1.session limit 1) as Calc_Steps,
(select count(*) from UserLogger where step not like 'UI_SOLVE%' and session=ul1.session limit 1) as Other_Steps
from UserLogger ul1
where Step='LO_START_SESSION'
order by Examples, UserName;

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
